searchNodes=[{"ref":"Mix.Tasks.RefInspector.Download.html","title":"Mix.Tasks.RefInspector.Download","type":"task","doc":"Mix task to download database file(s) from your command line. Arguments When run without arguments the task will display the target directory for the downloaded files and will ask for confirmation before downloading. --force: skip confirmation before downloading --quiet: silences task output (does not imply --force!) Informational README If you are using the default databases from the default remote location an informational README with the filename ref_inspector.readme.md will be placed next to the downloaded file(s). Inside you will find a link to the original database source. The creation of this file can be deactivated by configuration: config :ref_inspector, skip_download_readme: true"},{"ref":"Mix.Tasks.RefInspector.Download.html#run/1","title":"Mix.Tasks.RefInspector.Download.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"RefInspector.html","title":"RefInspector","type":"module","doc":"Referer parser library. Preparation Verify your supervision setup according to RefInspector.Supervisor Revise the default configuration values of RefInspector.Config and adjust to your project/environment where necessary Download a copy of the parser database file(s) as outlined in RefInspector.Downloader Usage iex&gt; RefInspector.parse(&quot;http://www.google.com/search?q=ref_inspector&quot;) %RefInspector.Result{ medium: &quot;search&quot;, referer: &quot;http://www.google.com/search?q=ref_inspector&quot;, source: &quot;Google&quot;, term: &quot;ref_inspector&quot; } Passing a referer string will result in a %RefInspector.Result{} returned with the following information (if available): :referer will contain the unmodified referer passed to the parser. :medium will be :unknown if no matching database entry could be found :internal, or a string matching the entry in the database. Detecting a referer as internal requires additional configuration. :source will be :unknown if no known source could be detected. Otherwise it will contain a string with the provider&#39;s name. :term will be :none if no query parameters were given or the provider has no configured term parameters in the database (mostly relevant for social or email referers). If a configured term parameter was found it will be an unencoded string (possibly empty). Note about Result Medium Atoms/Binaries The medium atoms :unknown and :internal are specially treated to reflect two special cases. One being reserved for completely unknown referers and one being for configured domains to not be parsed. Your database can still include &quot;unknown&quot; and &quot;internal&quot; sections. These will be parsed fully and returned using a binary as the medium instead of the aforementions atoms."},{"ref":"RefInspector.html#parse/1","title":"RefInspector.parse/1","type":"function","doc":"Parses a referer. Passing an empty referer (&quot;&quot; or nil) will directly return an empty result without accessing the database."},{"ref":"RefInspector.html#ready?/0","title":"RefInspector.ready?/0","type":"function","doc":"Checks if RefInspector is ready to perform lookups. The true == ready? definition is made on the assumption that if there is at least one referer in the database then lookups can be performed. Checking the state is done using the currently active database. Any potentially concurrent reload requests are not considered."},{"ref":"RefInspector.html#reload/1","title":"RefInspector.reload/1","type":"function","doc":"Reloads all databases. You can pass [async: true|false] to define if the reload should happen in the background or block your calling process until completed."},{"ref":"RefInspector.Config.html","title":"RefInspector.Config","type":"module","doc":"Module to simplify access to configuration values with default values. There should be no configuration required to start using :ref_inspector if you rely on the default values: config :ref_inspector, database_files: [&quot;referers.yml&quot;], database_path: Application.app_dir(:ref_inspector, &quot;priv&quot;), http_opts: [], remote_urls: [{&quot;referers.yml&quot;, &quot;https://s3-eu-west-1.amazonaws.com/snowplow-hosted-assets/third-party/referer-parser/referers-latest.yml&quot;}], startup_silent: false, startup_sync: false, yaml_file_reader: {:yamerl_constr, :file, [[:str_node_as_binary]]} The default :database_path is evaluated at runtime and not compiled into a release! How to Configure There are two ways to change the configuration values with the preferred way depending on your environment and personal taste. Static Configuration If you can ensure the configuration are static and not dependent on i.e. the server your application is running on, you can use a static approach by modifying your config.exs file: config :ref_inspector, database_files: [&quot;referers_search.yml&quot;, &quot;referers_social.yml&quot;], database_path: &quot;/path/to/ref_inspector/database_files&quot; Dynamic Configuration If a compile time configuration is not possible or does not match the usual approach taken in your application you can use a runtime approach. This is done by defining an initializer module that will automatically be called by RefInspector.Supervisor upon startup/restart. The configuration is expected to consist of a {mod, fun} or {mod, fun, args} tuple: # {mod, fun} config :ref_inspector, init: {MyInitModule, :my_init_mf} # {mod, fun, args} config :ref_inspector, init: {MyInitModule, :my_init_mfa, [:foo, :bar]} defmodule MyInitModule do @spec my_init_mf() :: :ok def my_init_mf(), do: my_init_mfa(:foo, :bar) @spec my_init_mfa(atom, atom) :: :ok def my_init_mfa(:foo, :bar) do priv_dir = Application.app_dir(:my_app, &quot;priv&quot;) Application.put_env(:ref_inspector, :database_path, priv_dir) end end The function is required to always return :ok. Startup Behaviour Databases are loaded asynchronously when starting the application using a :reload cast. This default behaviour can lead to the first parsing calls to work with an empty database and therefore not return the results you expect. You can change this behaviour to have the application force a synchronous database loading during the initial startup: config :ref_inspector, startup_sync: true Starting Silently When starting the application you will receive warnings if the database is not available. If you want to hide these messages you can configure the startup the be completely silent: config :ref_inspector, startup_silent: true This will automatically be set when calling the mix download task. Database Configuration Configuring the database to use can be done using three related values: :database_files :database_path :remote_urls The :database_path is the directory to look for when loading the databases. It is also the place where RefInspector.Downloader stores a copy of the configured files. For the actual files loaded there is :database_files, a list of filenames to load in the order specified. All files are expected to be inside the configured database path. When downloading the databases through RefInspector.Downloader the value :remote_urls is of utmost importance. It defines where each file is located. config :ref_inspector, remote_urls: [ &quot;http://example.com/database.yml&quot; {&quot;database_local.yml&quot;, &quot;http://example.com/database_remote.yml&quot;} ] To configure a remote database name you can either define a plain URL. It will be stored locally under the filename that is extracted from the url. In above example that would be &quot;database.yml&quot;. If the remote and local names match you can configure a {local, remote} tuple to deactivate the automatic name extraction. Download Configuration Using the default configuration all download requests for your database files are done using :hackney. To pass custom configuration values to hackney you can use the key :http_opts: config :ref_inspector, http_opts: [proxy: &quot;http://mycompanyproxy.com&quot;] Please see :hackney.request/5 for a complete list of available options. If you want to change the library used to download the databases you can configure a module implementing the RefInspector.Downloader.Adapter behaviour: config :ref_inspector, downloader_adapter: MyDownloaderAdapter YAML File Reader Configuration By default the library :yamerl will be used to read and decode the yaml database files. You can configure this reader to be a custom module: config :ref_inspector, yaml_file_reader: {module, function} config :ref_inspector, yaml_file_reader: {module, function, extra_args} The configured module will receive the file to read as the first argument with any optionally configured extra arguments after that."},{"ref":"RefInspector.Config.html#database_files/0","title":"RefInspector.Config.database_files/0","type":"function","doc":"Returns the list of configured database files."},{"ref":"RefInspector.Config.html#database_path/0","title":"RefInspector.Config.database_path/0","type":"function","doc":"Returns the configured database path. If the path is not defined the priv dir of :ref_inspector as returned by Application.app_dir(:ref_inspector, &quot;priv&quot;) will be used."},{"ref":"RefInspector.Config.html#default_files/0","title":"RefInspector.Config.default_files/0","type":"function","doc":"Returns the default list of database files."},{"ref":"RefInspector.Config.html#default_remote_database?/0","title":"RefInspector.Config.default_remote_database?/0","type":"function","doc":"Returns whether the remote database matches the default."},{"ref":"RefInspector.Config.html#default_urls/0","title":"RefInspector.Config.default_urls/0","type":"function","doc":"Returns the default list of database urls."},{"ref":"RefInspector.Config.html#downloader_adapter/0","title":"RefInspector.Config.downloader_adapter/0","type":"function","doc":"Returns the configured downloader adapter module. The modules is expected to adhere to the behaviour defined in RefInspector.Downloader.Adapter."},{"ref":"RefInspector.Config.html#get/2","title":"RefInspector.Config.get/2","type":"function","doc":"Provides access to configuration values with optional environment lookup."},{"ref":"RefInspector.Config.html#init_env/0","title":"RefInspector.Config.init_env/0","type":"function","doc":"Calls the optionally configured init method."},{"ref":"RefInspector.Config.html#yaml_file_reader/0","title":"RefInspector.Config.yaml_file_reader/0","type":"function","doc":"Returns the {mod, fun, extra_args} to be used when reading a yaml file."},{"ref":"RefInspector.Config.html#yaml_urls/0","title":"RefInspector.Config.yaml_urls/0","type":"function","doc":"Returns the remote urls of the database file."},{"ref":"RefInspector.Downloader.html","title":"RefInspector.Downloader","type":"module","doc":"Fetches copies of the configured database file(s). All files will be stored in the configured database path with the default setting being the result of Application.app_dir(:ref_inspector, &quot;priv&quot;). Please consult RefInspector.Config for details on database configuration. Mix Task Please see Mix.Tasks.RefInspector.Download if you are interested in using a mix task to obtain your database file(s)."},{"ref":"RefInspector.Downloader.html#download/0","title":"RefInspector.Downloader.download/0","type":"function","doc":"Performs the download of the configured database files."},{"ref":"RefInspector.Downloader.Adapter.html","title":"RefInspector.Downloader.Adapter","type":"behaviour","doc":"Behaviour for modules used by the downloader."},{"ref":"RefInspector.Downloader.Adapter.html#c:read_remote/1","title":"RefInspector.Downloader.Adapter.read_remote/1","type":"callback","doc":"Reads a database file from a remote location and returns it&#39;s contents."},{"ref":"RefInspector.Result.html","title":"RefInspector.Result","type":"module","doc":"Result struct."},{"ref":"RefInspector.Result.html#t:t/0","title":"RefInspector.Result.t/0","type":"type","doc":""},{"ref":"RefInspector.Supervisor.html","title":"RefInspector.Supervisor","type":"module","doc":"This supervisor module takes care of starting the required database storage processes. It is automatically started with the :ref_inspector application. If you do not want to automatically start the application itself you can adapt your configuration for a more manual supervision approach. Instead of adding :ref_inspector to your :applications list or using the automatic discovery you need to add it to your :included_applications: def application do [ included_applications: [ # ... :ref_inspector, # ... ] ] end That done you can add RefInspector.Supervisor to your hierarchy: children = [ # ... RefInspector.Supervisor, # .. ]"},{"ref":"RefInspector.Supervisor.html#child_spec/1","title":"RefInspector.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."}]